<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */


//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);

//Start the PHP session
session_start();

//Get the access token from the session
$accessToken = $_SESSION['accessToken'];

//Get the webhook id from the session
$webhookId = $_SESSION['webhookId'];

//Initiate CURL and set url endpoint including the webhook id
$ch = curl_init();
$url = "https://api.sandbox.paypal.com/v1/notifications/webhooks/$webhookId";
curl_setopt($ch, CURLOPT_URL, $url);

curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);

//Should to be set to true for security
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//Should be set to 2 for security
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

//Cert can be generated through mozilla firefox and is used when implementing security for VERIFYPEER and VERIFYHOST in the above
//curl_setopt($ch, CURLOPT_CAINFO, '/var/www/html/Example_REST_PO/cert/cacert.pem');

//Set headers including access token
$headers = array(
    'Accept: application/json',
    'Content-Type: application/json',
    'Accept-Language: en_US',
    "Authorization: Bearer $accessToken"
);
curl_setopt($ch,CURLOPT_HTTPHEADER,$headers);

//Let CURL know that we are using the PATCH method
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');

//Keep connection open until we get data back
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

//Reset the array
$vars= [];

//Specify the first change we want to make (replace the URL)
$change1['op'] = 'replace';
$change1['path'] = "/url";
$change1['value'] = 'https://example.com/example_webhook_2';

//Specify the second change we want to make (change the event types)
$change2['op'] = 'replace';
$change2['path'] = "/event_types";
$eventType['name'] = "PAYMENT.SALE.REFUNDED";
$change2['value'] = array($eventType);

//Build and set the json structure
$json = json_encode(array($change1, $change2));
curl_setopt($ch, CURLOPT_POSTFIELDS, $json);

//Print the json request
//echo $json;

//Get the response
$response = curl_exec($ch);

//Parse json into an array
$outArray = json_decode($response, true);

//Print the response
echo "<pre>";
print_r($outArray);
echo "</pre>";

//Verify that the webhook was updated successfully
if($outArray['id'] != null)
{
    ?>

<!DOCTYPE html>

<head>
<!-- Add meta tags for mobile and IE -->
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="X-UA-Compatible" content="IE=edge" />

<style type="text/css">
a.button {
    -webkit-appearance: button;
    -moz-appearance: button;
    appearance: button;
    
    text-decoration: none;
    color: initial;
    width:33.3%;
}

.bar{
    margin-left: 10%;
}
​
</style>
</head>

<body>

<div class="bar">
<a href="http://localhost/Sample_REST_Webhooks/createWebhook.php" class="button">Create Webhook</a>
<a href="http://localhost/Sample_REST_Webhooks/deleteWebhook.php" class="button">Delete Webhook</a>
<a href="http://localhost/Sample_REST_Webhooks/listAllWebhooks.php" class="button">List All Webhook</a>
<a href="http://localhost/Sample_REST_Webhooks/showWebhookDetails.php" class="button">Show Webhook Details</a>
</div>

</body>
<?php 
}
else
{
    //return user to store
    echo 'Sorry could not update webhook, please return to the store and try again';
    echo '<br><br>';
    echo"<a href='http://localhost/Sample_REST_Vault/index.php'>return to store</a>";
}