<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);

//Get access token from PayPal
include 'create-token.php';

//Get the data back from paypal
$data_received = json_decode(@file_get_contents("php://input"), true);

//Get all the headers
$headers_received = getallheaders();

//Concatinate the headers and data
$data = print_r($headers_received, true) . print_r($data_received, true);

//Place data in a text file
file_put_contents("webhook.log", $data);


//Initiate CURL and set the url endpoint
$ch = curl_init();
$url = 'https://api.sandbox.paypal.com/v1/notifications/verify-webhook-signature';
curl_setopt($ch, CURLOPT_URL, $url);

curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);

//Should to be set to true for security
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//Should be set to 2 for security
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

//Cert can be generated through mozilla firefox and is used when implementing security for VERIFYPEER and VERIFYHOST in the above
//curl_setopt($ch, CURLOPT_CAINFO, '/var/www/html/Example_REST_PO/cert/cacert.pem');

//Set headers including access token
$headers = array(
    'Accept: application/json',
    'Content-Type: application/json',
    'Accept-Language: en_US',
    "Authorization: Bearer $accessToken"
);
curl_setopt($ch,CURLOPT_HTTPHEADER,$headers);


//Lets curl know we are using 'post' and not 'get' (false = 'get')
curl_setopt($ch, CURLOPT_POST, TRUE);

//Keep connection open until we get data back
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

//Set the request body variables from the header information
$vars = [];
$vars['transmission_id'] = $headers_received['PAYPAL-TRANSMISSION-ID'];
$vars['transmission_time'] = $headers_received['PAYPAL-TRANSMISSION-TIME'];
$vars['cert_url'] = $headers_received['PAYPAL-CERT-URL'];
$vars['auth_algo'] = $headers_received['PAYPAL-AUTH-ALGO'];
$vars['transmission_sig'] = $headers_received['PAYPAL-TRANSMISSION-SIG'];
$vars['webhook_id'] = '0GT51747J9704721A';
$vars['webhook_event'] = $data_received;


//Build and set the json structure
$json = json_encode($vars);
curl_setopt($ch, CURLOPT_POSTFIELDS, $json);

//Get the response back
$response = curl_exec($ch);

//Print errors
// $errors =  'Curl error: ' . curl_error($ch);
// $info = curl_getinfo($ch);

// echo "errors: $errors";
// echo "info: <pre>";
// print_r($info);
// echo "</pre>";

//Close the connection
curl_close($ch);

//echo "response = $response";

//Write the data to a file
file_put_contents("webhookResponse.log", $response);

